libstdc++: __gnu_pbds::detail::splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc > Class Template Reference

libstdc++

__gnu_pbds::detail::splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc > Class Template Reference
Extensions » Policy-Based Data Structures » Containers » Branch-Based » Base and Policy Classes

`#include <splay_tree_.hpp>`

## Public Types
typedef _Alloc | allocator_type
typedef Cmp_Fn | cmp_fn
typedef std::pair< size_type, size_type > | comp_hash
typedef base_type::const_iterator | const_iterator
typedef base_type::const_pointer | const_pointer
typedef base_type::const_reference | const_reference
typedef base_type::const_reverse_iterator | const_reverse_iterator
typedef splay_tree_tag | container_category
typedef _Alloc::difference_type | difference_type
typedef base_type::iterator | iterator
typedef base_type::key_const_pointer | key_const_pointer
typedef base_type::key_const_reference | key_const_reference
typedef base_type::key_pointer | key_pointer
typedef base_type::key_reference | key_reference
typedef base_type::key_type | key_type
typedef base_type::mapped_const_pointer | mapped_const_pointer
typedef base_type::mapped_const_reference | mapped_const_reference
typedef base_type::mapped_pointer | mapped_pointer
typedef base_type::mapped_reference | mapped_reference
typedef base_type::mapped_type | mapped_type
typedef __nothrowcopy::indicator | no_throw_indicator
typedef traits_type::node_const_iterator | node_const_iterator
typedef traits_type::node_iterator | node_iterator
typedef base_type::node_update | node_update
typedef base_type::const_iterator | point_const_iterator
typedef base_type::point_iterator | point_iterator
typedef base_type::pointer | pointer
typedef base_type::reference | reference
typedef base_type::reverse_iterator | reverse_iterator
typedef _Alloc::size_type | size_type
typedef integral_constant< int, Store_Hash > | store_extra
typedef stored_data< value_type, size_type, Store_Hash > | stored_data_type
typedef base_type::value_type | value_type

## Public Member Functions
| splay_tree_map (const Cmp_Fn &)
| splay_tree_map (const Cmp_Fn &, const node_update &)
| splay_tree_map (const splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc > &)
iterator | begin ()
const_iterator | begin () const
void | clear ()
template<typename It>
void | copy_from_range (It, It)
bool | empty () const
iterator | end ()
const_iterator | end () const
iterator | erase (iterator it)
bool | erase (key_const_reference)
reverse_iterator | erase (reverse_iterator)
template<typename Pred>
size_type | erase_if (Pred)
point_iterator | find (key_const_reference)
point_const_iterator | find (key_const_reference) const
Cmp_Fn & | get_cmp_fn ()
const Cmp_Fn & | get_cmp_fn () const
void | initialize ()
std::pair< point_iterator, bool > | insert (const_reference r_value)
void | join (splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc > &)
point_iterator | lower_bound (key_const_reference)
point_const_iterator | lower_bound (key_const_reference) const
size_type | max_size () const
node_iterator | node_begin ()
node_const_iterator | node_begin () const
node_iterator | node_end ()
node_const_iterator | node_end () const
mapped_reference | operator[] (key_const_reference r_key)
reverse_iterator | rbegin ()
const_reverse_iterator | rbegin () const
reverse_iterator | rend ()
const_reverse_iterator | rend () const
size_type | size () const
void | split (key_const_reference, splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc > &)
void | swap (bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc > &)
void | swap (splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc > &)
point_iterator | upper_bound (key_const_reference)
point_const_iterator | upper_bound (key_const_reference) const

## Public Attributes
no_throw_indicator | m_no_throw_copies_indicator
store_extra | m_store_extra_indicator

## Protected Types
typedef node_alloc_traits::value_type | node
typedef node_alloc_traits::allocator_type | node_allocator
typedef traits_type::null_node_update_pointer | null_node_update_pointer
typedef types_traits< Key, Mapped, _Alloc, false > | traits_base

## Protected Member Functions
void | actual_erase_node (node_pointer)
template<typename Node_Update_>
void | apply_update (node_pointer, Node_Update_ *)
void | apply_update (node_pointer, null_node_update_pointer)
std::pair< node_pointer, bool > | erase (node_pointer)
node_pointer | get_new_node_for_leaf_insert (const_reference, false_type)
node_pointer | get_new_node_for_leaf_insert (const_reference, true_type)
void | initialize_min_max ()
iterator | insert_imp_empty (const_reference)
std::pair< point_iterator, bool > | insert_leaf (const_reference)
iterator | insert_leaf_new (const_reference, node_pointer, bool)
void | join_finish (bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc > &)
bool | join_prep (bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc > &)
size_type | recursive_count (node_pointer) const
void | rotate_left (node_pointer)
void | rotate_parent (node_pointer)
void | rotate_right (node_pointer)
void | split_finish (bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc > &)
bool | split_prep (key_const_reference, bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc > &)
void | update_min_max_for_erased_node (node_pointer)
void | update_subtree_size (node_pointer)
template<typename Node_Update_>
void | update_to_top (node_pointer, Node_Update_ *)
void | update_to_top (node_pointer, null_node_update_pointer)
void | value_swap (bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc > &)

## Static Protected Member Functions
static void | clear_imp (node_pointer)

## Protected Attributes
node_pointer | m_p_head
size_type | m_size

## Static Protected Attributes
static node_allocator | s_node_allocator

## Detailed Description

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>
class __gnu_pbds::detail::splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >

Splay tree.

Definition at line 107 of file splay_tree_.hpp.

## Member Typedef Documentation

## ◆ allocator_type

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef _Alloc __gnu_pbds::detail::splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::allocator_type

Definition at line 118 of file splay_tree_.hpp.

## ◆ cmp_fn

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef Cmp_Fn __gnu_pbds::detail::splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::cmp_fn

Definition at line 121 of file splay_tree_.hpp.

## ◆ comp_hash

typedef std::pair<size_type, size_type> __gnu_pbds::detail::types_traits< Key, Mapped, _Alloc, Store_Hash >::comp_hash
| inherited

Definition at line 187 of file types_traits.hpp.

## ◆ const_iterator

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef base_type::const_iterator __gnu_pbds::detail::splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::const_iterator

Definition at line 140 of file splay_tree_.hpp.

## ◆ const_pointer

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef base_type::const_pointer __gnu_pbds::detail::splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::const_pointer

Definition at line 134 of file splay_tree_.hpp.

## ◆ const_reference

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef base_type::const_reference __gnu_pbds::detail::splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::const_reference

Definition at line 136 of file splay_tree_.hpp.

## ◆ const_reverse_iterator

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef base_type::const_reverse_iterator __gnu_pbds::detail::splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::const_reverse_iterator

Definition at line 142 of file splay_tree_.hpp.

## ◆ container_category

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef splay_tree_tag __gnu_pbds::detail::splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::container_category

Definition at line 117 of file splay_tree_.hpp.

## ◆ difference_type

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef _Alloc::difference_type __gnu_pbds::detail::splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::difference_type

Definition at line 120 of file splay_tree_.hpp.

## ◆ iterator

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef base_type::iterator __gnu_pbds::detail::splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::iterator

Definition at line 139 of file splay_tree_.hpp.

## ◆ key_const_pointer

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef base_type::key_const_pointer __gnu_pbds::detail::splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::key_const_pointer

Definition at line 124 of file splay_tree_.hpp.

## ◆ key_const_reference

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef base_type::key_const_reference __gnu_pbds::detail::splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::key_const_reference

Definition at line 126 of file splay_tree_.hpp.

## ◆ key_pointer

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef base_type::key_pointer __gnu_pbds::detail::splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::key_pointer

Definition at line 123 of file splay_tree_.hpp.

## ◆ key_reference

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef base_type::key_reference __gnu_pbds::detail::splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::key_reference

Definition at line 125 of file splay_tree_.hpp.

## ◆ key_type

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef base_type::key_type __gnu_pbds::detail::splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::key_type

Definition at line 122 of file splay_tree_.hpp.

## ◆ mapped_const_pointer

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef base_type::mapped_const_pointer __gnu_pbds::detail::splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::mapped_const_pointer

Definition at line 129 of file splay_tree_.hpp.

## ◆ mapped_const_reference

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef base_type::mapped_const_reference __gnu_pbds::detail::splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::mapped_const_reference

Definition at line 131 of file splay_tree_.hpp.

## ◆ mapped_pointer

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef base_type::mapped_pointer __gnu_pbds::detail::splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::mapped_pointer

Definition at line 128 of file splay_tree_.hpp.

## ◆ mapped_reference

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef base_type::mapped_reference __gnu_pbds::detail::splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::mapped_reference

Definition at line 130 of file splay_tree_.hpp.

## ◆ mapped_type

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef base_type::mapped_type __gnu_pbds::detail::splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::mapped_type

Definition at line 127 of file splay_tree_.hpp.

## ◆ no_throw_indicator

typedef __nothrowcopy::indicator __gnu_pbds::detail::types_traits< Key, Mapped, _Alloc, Store_Hash >::no_throw_indicator
| inherited

Definition at line 189 of file types_traits.hpp.

## ◆ node

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef node_alloc_traits::value_type __gnu_pbds::detail::bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::node
| protectedinherited

Definition at line 120 of file bin_search_tree_.hpp.

## ◆ node_allocator

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef node_alloc_traits::allocator_type __gnu_pbds::detail::bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::node_allocator
| protectedinherited

Definition at line 118 of file bin_search_tree_.hpp.

## ◆ node_const_iterator

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef traits_type::node_const_iterator __gnu_pbds::detail::bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::node_const_iterator
| inherited

Definition at line 164 of file bin_search_tree_.hpp.

## ◆ node_iterator

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef traits_type::node_iterator __gnu_pbds::detail::bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::node_iterator
| inherited

Definition at line 165 of file bin_search_tree_.hpp.

## ◆ node_update

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef base_type::node_update __gnu_pbds::detail::splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::node_update

Definition at line 143 of file splay_tree_.hpp.

## ◆ null_node_update_pointer

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef traits_type::null_node_update_pointer __gnu_pbds::detail::bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::null_node_update_pointer
| protectedinherited

Definition at line 124 of file bin_search_tree_.hpp.

## ◆ point_const_iterator

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef base_type::const_iterator __gnu_pbds::detail::splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::point_const_iterator

Definition at line 138 of file splay_tree_.hpp.

## ◆ point_iterator

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef base_type::point_iterator __gnu_pbds::detail::splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::point_iterator

Definition at line 137 of file splay_tree_.hpp.

## ◆ pointer

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef base_type::pointer __gnu_pbds::detail::splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::pointer

Definition at line 133 of file splay_tree_.hpp.

## ◆ reference

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef base_type::reference __gnu_pbds::detail::splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::reference

Definition at line 135 of file splay_tree_.hpp.

## ◆ reverse_iterator

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef base_type::reverse_iterator __gnu_pbds::detail::splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::reverse_iterator

Definition at line 141 of file splay_tree_.hpp.

## ◆ size_type

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef _Alloc::size_type __gnu_pbds::detail::splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::size_type

Definition at line 119 of file splay_tree_.hpp.

## ◆ store_extra

typedef integral_constant<int, Store_Hash> __gnu_pbds::detail::types_traits< Key, Mapped, _Alloc, Store_Hash >::store_extra
| inherited

Definition at line 188 of file types_traits.hpp.

## ◆ stored_data_type

typedef stored_data<value_type, size_type, Store_Hash> __gnu_pbds::detail::types_traits< Key, Mapped, _Alloc, Store_Hash >::stored_data_type
| inherited

Definition at line 181 of file types_traits.hpp.

## ◆ traits_base

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef types_traits<Key, Mapped, _Alloc, false> __gnu_pbds::detail::bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::traits_base
| protectedinherited

Definition at line 115 of file bin_search_tree_.hpp.

## ◆ value_type

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

typedef base_type::value_type __gnu_pbds::detail::splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::value_type

Definition at line 132 of file splay_tree_.hpp.

## Constructor & Destructor Documentation

## ◆ splay_tree_map() [1/4]

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

__gnu_pbds::detail::splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::splay_tree_map | ( |  | ) |

Definition at line 55 of file splay_tree_.hpp.

## ◆ splay_tree_map() [2/4]

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

__gnu_pbds::detail::splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::splay_tree_map | ( | const Cmp_Fn & | r_cmp_fn | ) |

Definition at line 63 of file splay_tree_.hpp.

## ◆ splay_tree_map() [3/4]

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

__gnu_pbds::detail::splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::splay_tree_map | ( | const Cmp_Fn & | r_cmp_fn,
|  | const node_update & | r_node_update )

Definition at line 72 of file splay_tree_.hpp.

## ◆ splay_tree_map() [4/4]

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

__gnu_pbds::detail::splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::splay_tree_map | ( | const splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc > & | other | ) |

Definition at line 81 of file splay_tree_.hpp.

## Member Function Documentation

## ◆ actual_erase_node()

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

void __gnu_pbds::detail::bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::actual_erase_node | ( | node_pointer | p_z | ) |
| inlineprotectedinherited

Definition at line 46 of file bin_search_tree_.hpp.

## ◆ apply_update() [1/2]

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>
template<typename Node_Update_>

void __gnu_pbds::detail::bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::apply_update | ( | node_pointer | p_nd,
|  | Node_Update_ * | )
| inlineprotectedinherited

Definition at line 147 of file bin_search_tree_.hpp.

## ◆ apply_update() [2/2]

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

void __gnu_pbds::detail::bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::apply_update | ( | node_pointer | p_nd,
|  | null_node_update_pointer | )
| inlineprotectedinherited

Definition at line 138 of file bin_search_tree_.hpp.

## ◆ begin() [1/2]

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::iterator __gnu_pbds::detail::bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::begin | ( |  | ) |
| inlineinherited

Definition at line 46 of file bin_search_tree_.hpp.

## ◆ begin() [2/2]

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::const_iterator __gnu_pbds::detail::bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::begin | ( |  | ) | const
| inlineinherited

Definition at line 54 of file bin_search_tree_.hpp.

## ◆ clear()

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

void __gnu_pbds::detail::bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::clear | ( |  | ) |
| inherited

Definition at line 83 of file bin_search_tree_.hpp.

## ◆ clear_imp()

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

void __gnu_pbds::detail::bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::clear_imp | ( | node_pointer | p_nd | ) |
| staticprotectedinherited

Definition at line 96 of file bin_search_tree_.hpp.

## ◆ copy_from_range()

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>
template<typename It>

void __gnu_pbds::detail::splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::copy_from_range | ( | It | first_it,
|  | It | last_it )

Definition at line 47 of file splay_tree_.hpp.

## ◆ empty()

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

bool __gnu_pbds::detail::bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::empty | ( |  | ) | const
| inlinenodiscardinherited

Definition at line 47 of file bin_search_tree_.hpp.

## ◆ end() [1/2]

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::iterator __gnu_pbds::detail::bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::end | ( |  | ) |
| inlineinherited

Definition at line 62 of file bin_search_tree_.hpp.

## ◆ end() [2/2]

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::const_iterator __gnu_pbds::detail::bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::end | ( |  | ) | const
| inlineinherited

Definition at line 70 of file bin_search_tree_.hpp.

## ◆ erase() [1/3]

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::iterator __gnu_pbds::detail::splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::erase | ( | iterator | it | ) |
| inline

Definition at line 58 of file splay_tree_.hpp.

## ◆ erase() [2/3]

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

bool __gnu_pbds::detail::splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::erase | ( | key_const_reference | r_key | ) |
| inline

Definition at line 46 of file splay_tree_.hpp.

## ◆ erase() [3/3]

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::reverse_iterator __gnu_pbds::detail::splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::erase | ( | reverse_iterator | it | ) |
| inline

Definition at line 73 of file splay_tree_.hpp.

## ◆ erase_if()

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>
template<typename Pred>

splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::size_type __gnu_pbds::detail::splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::erase_if | ( | Pred | pred | ) |
| inline

Definition at line 89 of file splay_tree_.hpp.

## ◆ find() [1/2]

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::point_iterator __gnu_pbds::detail::splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::find | ( | key_const_reference | r_key | ) |
| inline

Definition at line 46 of file splay_tree_.hpp.

## ◆ find() [2/2]

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::point_const_iterator __gnu_pbds::detail::splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::find | ( | key_const_reference | r_key | ) | const
| inline

Definition at line 57 of file splay_tree_.hpp.

## ◆ get_cmp_fn() [1/2]

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

Cmp_Fn & __gnu_pbds::detail::bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::get_cmp_fn | ( |  | ) |
| inherited

Definition at line 46 of file bin_search_tree_.hpp.

## ◆ get_cmp_fn() [2/2]

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

const Cmp_Fn & __gnu_pbds::detail::bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::get_cmp_fn | ( |  | ) | const
| inherited

Definition at line 52 of file bin_search_tree_.hpp.

## ◆ get_new_node_for_leaf_insert()

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::node_pointer __gnu_pbds::detail::bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::get_new_node_for_leaf_insert | ( | const_reference | r_val,
|  | false_type | )
| inlineprotectedinherited

Definition at line 153 of file bin_search_tree_.hpp.

## ◆ initialize()

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

void __gnu_pbds::detail::splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::initialize | ( |  | ) |

Definition at line 103 of file splay_tree_.hpp.

## ◆ initialize_min_max()

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

void __gnu_pbds::detail::bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::initialize_min_max | ( |  | ) |
| protectedinherited

Definition at line 198 of file bin_search_tree_.hpp.

## ◆ insert()

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

std::pair< typename splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::point_iterator, bool > __gnu_pbds::detail::splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::insert | ( | const_reference | r_value | ) |
| inline

Definition at line 46 of file splay_tree_.hpp.

## ◆ insert_imp_empty()

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::iterator __gnu_pbds::detail::bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::insert_imp_empty | ( | const_reference | r_value | ) |
| inlineprotectedinherited

Definition at line 135 of file bin_search_tree_.hpp.

## ◆ insert_leaf()

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

std::pair< typename bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::point_iterator, bool > __gnu_pbds::detail::bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::insert_leaf | ( | const_reference | r_value | ) |
| inlineprotectedinherited

Definition at line 46 of file bin_search_tree_.hpp.

## ◆ insert_leaf_new()

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::iterator __gnu_pbds::detail::bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::insert_leaf_new | ( | const_reference | r_value,
|  | node_pointer | p_nd,
|  | bool | left_nd )
| inlineprotectedinherited

Definition at line 97 of file bin_search_tree_.hpp.

## ◆ join()

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

void __gnu_pbds::detail::splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::join | ( | splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc > & | other | ) |
| inline

Definition at line 46 of file splay_tree_.hpp.

## ◆ join_finish()

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

void __gnu_pbds::detail::bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::join_finish | ( | bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc > & | other | ) |
| protectedinherited

Definition at line 81 of file bin_search_tree_.hpp.

## ◆ join_prep()

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

bool __gnu_pbds::detail::bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::join_prep | ( | bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc > & | other | ) |
| protectedinherited

Definition at line 46 of file bin_search_tree_.hpp.

## ◆ lower_bound() [1/2]

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::point_iterator __gnu_pbds::detail::bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::lower_bound | ( | key_const_reference | r_key | ) |
| inlineinherited

Definition at line 65 of file bin_search_tree_.hpp.

## ◆ lower_bound() [2/2]

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::point_const_iterator __gnu_pbds::detail::bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::lower_bound | ( | key_const_reference | r_key | ) | const
| inlineinherited

Definition at line 46 of file bin_search_tree_.hpp.

## ◆ max_size()

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::size_type __gnu_pbds::detail::bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::max_size | ( |  | ) | const
| inlineinherited

Definition at line 63 of file bin_search_tree_.hpp.

## ◆ node_begin() [1/2]

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::node_iterator __gnu_pbds::detail::bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::node_begin | ( |  | ) |
| inlineinherited

Returns a node_iterator corresponding to the node at the root of the tree.

Definition at line 118 of file bin_search_tree_.hpp.

## ◆ node_begin() [2/2]

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::node_const_iterator __gnu_pbds::detail::bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::node_begin | ( |  | ) | const
| inlineinherited

Returns a const node_iterator corresponding to the node at the root of the tree.

Definition at line 110 of file bin_search_tree_.hpp.

## ◆ node_end() [1/2]

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::node_iterator __gnu_pbds::detail::bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::node_end | ( |  | ) |
| inlineinherited

Returns a node_iterator corresponding to a node just after a leaf of the tree.

Definition at line 134 of file bin_search_tree_.hpp.

## ◆ node_end() [2/2]

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::node_const_iterator __gnu_pbds::detail::bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::node_end | ( |  | ) | const
| inlineinherited

Returns a const node_iterator corresponding to a node just after a leaf of the tree.

Definition at line 126 of file bin_search_tree_.hpp.

## ◆ operator[]()

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

mapped_reference __gnu_pbds::detail::splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::operator[] | ( | key_const_reference | r_key | ) |
| inline

Definition at line 167 of file splay_tree_.hpp.

## ◆ rbegin() [1/2]

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::reverse_iterator __gnu_pbds::detail::bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::rbegin | ( |  | ) |
| inlineinherited

Definition at line 86 of file bin_search_tree_.hpp.

## ◆ rbegin() [2/2]

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::const_reverse_iterator __gnu_pbds::detail::bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::rbegin | ( |  | ) | const
| inlineinherited

Definition at line 78 of file bin_search_tree_.hpp.

## ◆ recursive_count()

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::size_type __gnu_pbds::detail::bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::recursive_count | ( | node_pointer | p | ) | const
| protectedinherited

Definition at line 148 of file bin_search_tree_.hpp.

## ◆ rend() [1/2]

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::reverse_iterator __gnu_pbds::detail::bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::rend | ( |  | ) |
| inlineinherited

Definition at line 94 of file bin_search_tree_.hpp.

## ◆ rend() [2/2]

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::const_reverse_iterator __gnu_pbds::detail::bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::rend | ( |  | ) | const
| inlineinherited

Definition at line 102 of file bin_search_tree_.hpp.

## ◆ rotate_left()

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

void __gnu_pbds::detail::bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::rotate_left | ( | node_pointer | p_x | ) |
| inlineprotectedinherited

Definition at line 46 of file bin_search_tree_.hpp.

## ◆ rotate_parent()

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

void __gnu_pbds::detail::bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::rotate_parent | ( | node_pointer | p_nd | ) |
| inlineprotectedinherited

Definition at line 108 of file bin_search_tree_.hpp.

## ◆ rotate_right()

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

void __gnu_pbds::detail::bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::rotate_right | ( | node_pointer | p_x | ) |
| inlineprotectedinherited

Definition at line 77 of file bin_search_tree_.hpp.

## ◆ size()

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::size_type __gnu_pbds::detail::bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::size | ( |  | ) | const
| inlineinherited

Definition at line 55 of file bin_search_tree_.hpp.

## ◆ split()

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

void __gnu_pbds::detail::splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::split | ( | key_const_reference | r_key,
|  | splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc > & | other )

Definition at line 82 of file splay_tree_.hpp.

## ◆ split_finish()

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

void __gnu_pbds::detail::bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::split_finish | ( | bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc > & | other | ) |
| protectedinherited

Definition at line 133 of file bin_search_tree_.hpp.

## ◆ split_prep()

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

bool __gnu_pbds::detail::bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::split_prep | ( | key_const_reference | r_key,
|  | bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc > & | other )
| protectedinherited

Definition at line 90 of file bin_search_tree_.hpp.

## ◆ swap() [1/2]

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

void __gnu_pbds::detail::bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::swap | ( | bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc > & | other | ) |
| inherited

Definition at line 114 of file bin_search_tree_.hpp.

## ◆ swap() [2/2]

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

void __gnu_pbds::detail::splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::swap | ( | splay_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc > & | other | ) |

Definition at line 91 of file splay_tree_.hpp.

## ◆ update_min_max_for_erased_node()

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

void __gnu_pbds::detail::bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::update_min_max_for_erased_node | ( | node_pointer | p_z | ) |
| inlineprotectedinherited

Definition at line 58 of file bin_search_tree_.hpp.

## ◆ update_subtree_size()

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

void __gnu_pbds::detail::bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::update_subtree_size | ( | node_pointer | p_nd | ) |
| inlineprotectedinherited

Definition at line 125 of file bin_search_tree_.hpp.

## ◆ update_to_top() [1/2]

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>
template<typename Node_Update_>

void __gnu_pbds::detail::bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::update_to_top | ( | node_pointer | p_nd,
|  | Node_Update_ * | p_update )
| inlineprotectedinherited

Definition at line 158 of file bin_search_tree_.hpp.

## ◆ update_to_top() [2/2]

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

void __gnu_pbds::detail::bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::update_to_top | ( | node_pointer | p_nd,
|  | null_node_update_pointer | )
| inlineprotectedinherited

Definition at line 171 of file bin_search_tree_.hpp.

## ◆ upper_bound() [1/2]

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::point_iterator __gnu_pbds::detail::bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::upper_bound | ( | key_const_reference | r_key | ) |
| inlineinherited

Definition at line 103 of file bin_search_tree_.hpp.

## ◆ upper_bound() [2/2]

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::point_const_iterator __gnu_pbds::detail::bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::upper_bound | ( | key_const_reference | r_key | ) | const
| inlineinherited

Definition at line 84 of file bin_search_tree_.hpp.

## ◆ value_swap()

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

void __gnu_pbds::detail::bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::value_swap | ( | bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc > & | other | ) |
| protectedinherited

Definition at line 127 of file bin_search_tree_.hpp.

## Member Data Documentation

## ◆ m_no_throw_copies_indicator

no_throw_indicator __gnu_pbds::detail::types_traits< Key, Mapped, _Alloc, Store_Hash >::m_no_throw_copies_indicator
| inherited

Definition at line 192 of file types_traits.hpp.

## ◆ m_p_head

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

node_pointer __gnu_pbds::detail::bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::m_p_head
| protectedinherited

Definition at line 398 of file bin_search_tree_.hpp.

## ◆ m_size

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

size_type __gnu_pbds::detail::bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::m_size
| protectedinherited

Definition at line 399 of file bin_search_tree_.hpp.

## ◆ m_store_extra_indicator

store_extra __gnu_pbds::detail::types_traits< Key, Mapped, _Alloc, Store_Hash >::m_store_extra_indicator
| inherited

Definition at line 191 of file types_traits.hpp.

## ◆ s_node_allocator

template<typename Key, typename Mapped, typename Cmp_Fn, typename Node_And_It_Traits, typename _Alloc>

node_allocator __gnu_pbds::detail::bin_search_tree_map< Key, Mapped, Cmp_Fn, Node_And_It_Traits, _Alloc >::s_node_allocator
| staticprotectedinherited

Definition at line 400 of file bin_search_tree_.hpp.

The documentation for this class was generated from the following file:

- splay_tree_.hpp